<template>
	<div class="col-xs-12">
		<h1>General settings</h1>
		<form>
			<div class="repeater" v-for="block in blocks">
				<div class="col-xs-10">
					<div class="row">
						<div class="form-group col-sm-3">
							<label>Attribute name</label>
							<input type="text" v-model="block.name" name="attr_name" class="form-control">
						</div>
						<div class="form-group col-sm-3">
							<label>Attribute code</label>
							<input type="text" name="attr_code" v-model="block.code" class="form-control">
						</div>
						<div class="form-group col-sm-1">
							<label>Position on the product page</label>
							<input type="number" name="product_position" v-model="block.position" class="form-control">
						</div>
						<div class="form-group col-sm-2">
							<label>Is column?</label>
							<input type="checkbox" name="is_column" v-model="block.is_column" :checked="false"
							       class="form-control">
						</div>
						<div v-show="block.is_column">
							<div class="form-group col-sm-1">
								<label>Column position</label>
								<input type="number" name="column_position" v-model="block.column_position"
								       class="form-control">
							</div>
							<div class="form-group col-sm-2">
								<label>Attribute type</label>
								<select v-model="block.attr_type">
									<option v-for="type in attribute_types" v-bind:value="type.code">{{type.name}}
									</option>
								</select>
							</div>
						</div>
					</div>
				</div>
				<div class="col-xs-2">
					<span class="btn btn-default custom-attrs-form__save" @click="submitForm(block)">Save</span>
					<span class="btn btn-danger repeater__button--delete"
					      @click="deleteRepeaterBlock(block)">Delete</span>
				</div>
			</div>
			<div class="col-sm-12">
				<span class="btn btn-default repeater__button--add" @click="addRepeaterBlock()">Add row</span>
			</div>
		</form>
	</div>
</template>
<style>

</style>
<script>
	export default{
		data(){
			return {
				blocks: [{}],
				attribute_types: [{}]
			}
		},
		route: {
			data(transition) {
				return this.$http.get('/api/v1/product-attributes').then(function (res) {

					return {
						blocks: res.data,
						attribute_types: this.getTypeOptions()
					}
				});
			}
		},
		methods: {
			addRepeaterBlock: function (event) {
//				var value = this.newTodo && this.newTodo.trim();
//				if (!value) {
//					return;
//				}
				this.blocks.push({});
			},
			deleteRepeaterBlock: function (block) {
				if (block.id) {
					this.$http.delete('/api/v1/product-attributes/delete/' + block.id).then(function (res) {
						this.blocks.$remove(block);
					});
				} else {
					this.blocks.$remove(block);
				}
			},
			submitForm: function (block) {
//				var attributes = [];
//				blocks.forEach(function (v) {
//					var attribute = {};
//					attribute.name = v.attr_name;
//					attribute.code = v.attr_code;
//					attributes.push(attribute);
//				});
				console.log(block);
				if (block.id) {
					this.$http.put('/api/v1/product-attributes/update/' + block.id, block).then(function (res) {
						console.log(res.data);
					})
				} else {
					this.$http.post('/api/v1/product-attributes/create', block).then(function (res) {
						console.log(res.data);
					})
				}
			},
			getTypeOptions: function () {
				return this.$http.get('/api/v1/settings/attribute_types').then(function (res) {
					return res.data.data
				})
			}
		},
		components: {}
	}
</script>